#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.impl;

import org.coos.messaging.Consumer;
import org.coos.messaging.Processor;
import org.coos.messaging.Producer;
import org.coos.messaging.Service;
import org.coos.messaging.impl.DefaultEndpoint;
import org.coos.messaging.util.Log;
import org.coos.messaging.util.LogFactory;

public class ${parentArtifactId}Endpoint extends DefaultEndpoint {

    private Consumer consumer;
    private Producer producer;
    private static final Log LOG = LogFactory.getLog(${parentArtifactId}Endpoint.class.getName());

    public ${parentArtifactId}Endpoint() {
    }

    public ${parentArtifactId}Endpoint(String uri, Processor processor) {
        super(uri, processor);
    }
    
    @Override
    public Consumer createConsumer() {
        if (consumer == null) {
            consumer = new ${parentArtifactId}Consumer(this);
        }
        return consumer;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Producer createProducer() {
        if(producer == null) {
            producer = new ${parentArtifactId}Producer(this);
            getServices().addElement(producer);
            try {
                ((Service) producer).start();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return producer;
    }
    
    @Override
    public void start() throws Exception {
        LOG.debug("Starting endpoint");
    }

    @Override
    public void stop() throws Exception {
        LOG.debug("Stopping endpoint");
    }

}

